#ifndef UKUI_SETTINGS_MONITOR_H
#define UKUI_SETTINGS_MONITOR_H

#include <QObject>
#include "singleton.h"

class GsettingsMonitor;
class HorizontalOrVerticalMode;

class UkuiSettingsMonitor final : public QObject,
                                  public Singleton<UkuiSettingsMonitor>
{
    Q_OBJECT
    friend class Singleton<UkuiSettingsMonitor>;
private:
    UkuiSettingsMonitor();
    ~UkuiSettingsMonitor() override;
public:
    enum TabletStatus {
        None = 0,
        PADHorizontalMode = 1, //平板横屏
        PADVerticalMode = 2,   //平板竖屏
        PCMode = 3             // pc模式
    };

    enum StyleStatus{
        NONE = 0,
        LIGHT,
        DARK
    };


    void startTest(TabletStatus status = None);
    int transparency() const;
    StyleStatus styleStatus() const;
    TabletStatus tabletMode() const;

signals:
    void transparencyUpdate(int transparency);
    void styleStatusUpdate(StyleStatus styleStatus);
    void tabletModeUpdate(TabletStatus tabletMode);

private:
    GsettingsMonitor *d_ptrGsetting{nullptr};
    HorizontalOrVerticalMode *d_ptrDbus{nullptr};
};




#endif // UKUI_SETTINGS_MONITOR_H